################
# Ex3 solution #
################
# Import lon.csv. May use the GUI of ReGenesees or the command line (change the
# path to the file if needed)
lon <- read.table(file="lon.csv", header=TRUE, sep=";", na.strings=NA, quote="\"", dec=".", strip.white=TRUE, comment.char="")

# Define londes:
londes <- e.svydesign(data=lon, ids=~psu+ssu, strata=~stratum, weights=~w, fpc=~fpc1+fpc2)
londes

# Test that londes has lonely PSUs:
find.lon.strata(londes)
# Two lonely strata found.

# As for the block variable for strata collapsing, there are only 4 factor
# candidates:
str(lon)
# namely: 'stratum', 'dom1', 'dom2', 'pl.domain'

# Of course 'stratum' cannot work. Also 'dom1' and 'dom2' are ruled out, as they
# cut across strata.
# Indeed, e.g.:
collapse.strata(londes, block.vars = ~dom1)
clps.strata.status

# Only 'pl.domain' can serve the purpose of blocking:
londes.clps <- collapse.strata(londes, block.vars = ~pl.domain)
londes.clps

# Printing on screen, one realizes that londes.clps has 3 strata:
londes.clps

## A: When strata collapsing is successful, the mapping of original strata
##    to the resulting superstrata is reported inside the diagnostic object
##    'clps.strata.status':
clps.strata.status

## That is: lonely stratum 'S.3' has been aggregated with 'S.1' and lonely stratum
## 'S.5' to 'S.4'.
